﻿using HBLConsole.Communication;
using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BPASmartClient.Business
{
    public class MQTTMgr : IPlugin
    {
        //消息缓存
        private ConcurrentQueue<string> msg = new ConcurrentQueue<string>();

        public void Initialize()
        {
            //MQTT 重连成功
            MqttHelper.GetInstance().Reconnection = new Action(() =>
            {
                MqttHelper.GetInstance().MqttSubscriptionAsync(TopicDefine.GetInstance().SubscribTopics.ToArray());
            });

            //MQTT 连接成功
            MqttHelper.GetInstance().ConnectOk = new Action(() =>
            {
                MqttHelper.GetInstance().MqttSubscriptionAsync(TopicDefine.GetInstance().SubscribTopics.ToArray());
            });
            //MQTT 数据接收
            MqttHelper.GetInstance().MqttReceive = new Action<MQTTnet.MqttApplicationMessageReceivedEventArgs>((receivce) =>
            {
                msg.Enqueue(Encoding.UTF8.GetString(receivce.ApplicationMessage.Payload));
            });
            //MQTT 初始化
            MqttHelper.GetInstance().MqttInitAsync(InternetInfo.MqttUserName, InternetInfo.MqttPassword,
                InternetInfo.MqttAddress, InternetInfo.MqttPort, DateTime.Now.ToString("yyyy-MM-dd-HH-mm-ss"));
        }

        public void Dispose()
        {
            MqttHelper.GetInstance().Close();
        }
    }
}
